<template>
    <div id="view-graph" ref="viewGraph"
        class="mt-3"
        :style="{height: height + 'px', maxHeight: height + 'px'}">
    </div>
</template>

<style scoped>
#view-graph {
    border: 1px red solid;
    margin: 0 auto;
    width: 100%;
    overflow: hidden;
}
</style>

<style>
.text-block {
    cursor: move;
}
.text-block.active {
    fill: #252525;
}
</style>

<script>
    import Plotly from 'plotly.js-dist'
    import { getPlotlyData } from '../../services/budgetGraphFunctions'

    export default {
        name: 'BudgetViewGraph',
        props: {
            view: Object,
            width: {
                default: 1000,
                type: Number,
            },
            height: {
                default: 800,
                type: Number,
            },
        },
        computed: {
            graphData() {
                return getPlotlyData(this.view.items, this.view.codeType)
            }
        },
        methods: {
            updateGraph() {
                console.log(this.graphData);

                var data = [{
                    type: "sankey",
                    orientation: "v",
                    node: {
                        pad: 15,
                        thickness: 30,
                        line: {
                            color: "black",
                            width: 0.5
                        },
                        label: this.graphData.nodes.map(node => node.aliasName),
                        color: this.graphData.nodes.map(node => node.color),
                    },
                    link: {
                        source: this.graphData.links.map(link => link.source),
                        target: this.graphData.links.map(link => link.target),
                        value: this.graphData.links.map(link => link.value)
                    }
                }]

                var layout = {
                    title: "Бюджет",
                    width: this.width,
                    height: this.height,
                    font: {
                        size: 10
                    }
                }

                Plotly.react('view-graph', data, layout)
            }
        },
        watch: {
            view: function() {
                this.updateGraph();
            }
        },
        mounted() {
            this.updateGraph();
        }
    }
</script>